SetCuttersStateEvent = {};
SetCuttersStateEvent_mt = Class(SetCuttersStateEvent, Event);

InitEventClass(SetCuttersStateEvent, "SetCuttersStateEvent");

function SetCuttersStateEvent:emptyNew()
    local self = Event:new(SetCuttersStateEvent_mt);
    self.className = "SetCuttersStateEvent";
    return self;
end;

function SetCuttersStateEvent:new(object, validCutters)
    local self = SetCuttersStateEvent:emptyNew()
    self.object = object;
	self.validCutters = {};
	for i=1,4 do
		self.validCutters[i] = validCutters[i];
	end
    return self;
end;

function SetCuttersStateEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.validCutters = {};
	for i=1,4 do
		self.validCutters[i] = streamReadBool(streamId);
	end;
    self:run(connection);
end;

function SetCuttersStateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	for i=1,4 do
		streamWriteBool(streamId, self.validCutters[i]);
	end;
end;

function SetCuttersStateEvent:run(connection)
	self.object:setCuttersState(self.validCutters, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetCuttersStateEvent:new(self.object, self.validCutters), nil, connection, self.object);
	end;
end;

function SetCuttersStateEvent.sendEvent(vehicle, validCutters, noEventSend)
--print("function SetCuttersStateEvent.sendEvent(vehicle, validCutters, noEventSend)");
	local doUpdate = false;
	for i=1,4 do 
		if validCutters[i] ~= vehicle.psStateSend[i] then
			doUpdate = true;
		end;
	end;
	if doUpdate == true then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(SetCuttersStateEvent:new(vehicle, validCutters), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(SetCuttersStateEvent:new(vehicle, validCutters));
			end;
		end;
	end;
end;

